import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { RouteReuseStrategy } from '@angular/router';

import { IonicModule, IonicRouteStrategy } from '@ionic/angular';
import { SplashScreen } from '@ionic-native/splash-screen/ngx';
import { StatusBar } from '@ionic-native/status-bar/ngx';

import { AppComponent } from './app.component';
import { AppRoutingModule } from './app-routing.module';
// เพิ่มการเชื่อมต่อ service
import { HttpClientModule} from '@angular/common/http';
// เพิ่มการเช็คสถานะ Network
import { Network } from '@ionic-native/network/ngx';
// เพิ่มการบันทึกข้อมูลลงอุปกรณ์
import { IonicStorageModule } from '@ionic/storage';
// เพิ่มกล้อง
import { Camera } from '@ionic-native/camera/ngx';
// เพิ่มการส่งไฟล์หลังบ้าน
import { FileTransfer } from '@ionic-native/file-transfer/ngx';
import { OneSignal } from '@ionic-native/onesignal/ngx';
import { SuperTabsModule} from '@ionic-super-tabs/angular'

@NgModule({
  declarations: [AppComponent],
  entryComponents: [],
  imports: [
    BrowserModule, 
    IonicModule.forRoot(), 
    AppRoutingModule,
    HttpClientModule,
    IonicStorageModule.forRoot(),
    SuperTabsModule.forRoot()
  ],
  providers: [
    StatusBar,
    SplashScreen,
    { provide: RouteReuseStrategy, useClass: IonicRouteStrategy },
    Camera,
    Network,
    FileTransfer,
    OneSignal
  ],
  bootstrap: [AppComponent]
})
export class AppModule {}
