import { Component, OnInit } from '@angular/core';
import { NavController, NavParams, ActionSheetController, LoadingController } from '@ionic/angular';
import { ApiService } from '../services/api.service';
import { Storage } from '@ionic/storage';

@Component({
  selector: 'app-chronic',
  templateUrl: './chronic.page.html',
  styleUrls: ['./chronic.page.scss'],
})
export class ChronicPage implements OnInit {
  items;
  patienCare: any;
  patienCareHistory: any;
  hospcode: any;
  username: string;
  event: any;
  ev: any;
  search: any;
  tempPatienCare: any;
  sex: any;

  constructor(
    public navController: NavController,
    public actionSheetController: ActionSheetController,
    private apiService: ApiService,
    private storage: Storage,

  ) {
  }

  ngOnInit() {
  }

  ionViewWillEnter() {
    this.storage.get('user').then(
      res => {
        this.apiService.getChronic(res.hospcode, res.cid).subscribe(
          data => {
            // console.log(data);
            // console.log(data.rows);
            this.patienCare = data.rows;
            this.tempPatienCare = data.rows;
          }
        )
      }
    )
  }

  getItems() {
    // Reset items back to all of the items
    // console.log(this.search);
    if (this.search) {
      this.apiService.getSearchChronic(this.search).subscribe(
        data => {
          this.patienCare = data.rows
          // console.log(data.rows);
        }
      )
    } else {
      this.patienCare = this.tempPatienCare
    }
  }

  async presentActionSheet(cid: any, fname: any, lname: any, sex: any) {
    const actionSheet = await this.actionSheetController.create({
      //header: 'เมนู',
      mode: 'ios',
      buttons: [{
        text: 'บันทึกข้อมูล',
        role: 'destructive',
        icon: 'create',
        handler: () => {
          // console.log('Delete clicked');
          this.navController.navigateForward('/screen/' + cid + '/' + fname + '/' + lname + '/' + sex);
          // console.log(fname);

        }
      },
      {
        text: 'ประวัติ',
        icon: 'contact',
        handler: () => {
          // console.log('Play clicked');
          this.navController.navigateForward('/history/' + cid + '/' + fname + '/' + lname + '/' + sex)
        }
      }, {
        text: 'ยกเลิก',
        icon: 'close',
        role: 'cancel',
        handler: () => {
          // console.log('Cancel clicked');
        }
      }]
    });
    await actionSheet.present();
  }

  showHistory(cid: any, fname: any, lname: any, sex: any) {
    this.navController.navigateForward('/history/' + cid + '/' + fname + '/' + lname + '/' + sex);
  }

}