import { Component, OnInit, ViewChild } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AlertController, NavController } from '@ionic/angular';
import { ApiService } from '../services/api.service';
import { Chart } from 'chart.js';

@Component({
  selector: 'app-history',
  templateUrl: './history.page.html',
  styleUrls: ['./history.page.scss'],
})
export class HistoryPage implements OnInit {
  @ViewChild('lineChartHt', { read: false, static: false }) lineChartHt;
  @ViewChild('lineChartDm', { read: false, static: false }) lineChartDm;

  fname: any;
  lname: any;
  hospcode: any;
  history: any;
  cid: any;
  profile: any;
  sex: any;
  chart: any;
  htchart: any;
  dmchart: any;
  checkBoxList: any;
  // Age: any;
  // Gender: any;
  // SBP: any;
  // DM: any;
  // CHOL: any;
  // Smoking: any;
  // LDL: any;
  // Waist: any;
  // GFR: any;
  // Height: any;
  LastScreenResult: any;
  riskstroke: any;
  riskckd: any;
  constructor(
    private activatedRoute: ActivatedRoute,
    public navController: NavController,
    private apiService: ApiService,
    public alertController: AlertController,
  ) {
    this.cid = this.activatedRoute.snapshot.paramMap.get('cid');
    this.fname = this.activatedRoute.snapshot.paramMap.get('fname');
    this.lname = this.activatedRoute.snapshot.paramMap.get('lname');
    this.sex = this.activatedRoute.snapshot.paramMap.get('sex');
    this.checkBoxList = [
      {
        value: 'เลิกสูบบุหรี่',
        isChecked: false
      }, {
        value: 'ควบคุมความดันโลหิตให้อยู่ในระดับปกติ',
        isChecked: false
      }, {
        value: 'ควบคุมอาหาร ลดรอบเอวลง 2 นิ้ว',
        isChecked: false
      }
    ];
  }

//   ionViewWillLeave(){
//     //this.subscription.unsubscribe();
//     //this.navController.navigateForward('/chronic');
//     console.log('Leaving Sign in Page');
// }
  calStrokeRisk(Age, Gender, SBP, DM, CHOL, Smoking, LDL, Waist, GFR, Height) {

    let Risk_Chol = parseFloat(String((1 - (Math.pow(0.964588, (Math.exp((((0.0818347640193792 * Age) +
    (0.394986128542107 * Gender) + (0.0208425438624519 * SBP) + (0.699741921871077 * DM) +
    (0.00212384055469836 * CHOL) + (0.419162811751856 * Smoking)) - 7.044233)))))) * 100)).toFixed(1);

    let Risk_LDL = parseFloat(String((1 - (Math.pow(0.964588, (Math.exp(((( 0.0816928089139167 * Age ) +
     ( 0.351564186167652 * Gender ) + ( 0.0208425438624519 * SBP )+ ( 0.650521645524925 * DM ) +
     ( 0.00209444039627453 * LDL ) + ( 0.456391033892148 * Smoking )) - 6.99911 ) ) ) ) ) ) * 100)).toFixed(1);

    let Risk_Obesity = parseFloat(String((1 - (Math.pow(0.964588, ( Math.exp(((( 0.0794420169146399 * Age ) +
     ( 0.127658073818733 * Gender ) + ( 0.0193509871323239 * SBP ) + ( 0.584543504554125 * DM ) +
     ( 0.0351256637183026 * ( Waist / Height ) * 100 ) + ( 0.459312425773018 * Smoking )) - 7.712325 ) ) ) ) ) ) * 100)).toFixed(1);

    if (CHOL > 0) {
      this.riskstroke =  Risk_Chol;
    } else if (LDL > 0) {
      this.riskstroke =  Risk_LDL;
    } else {
      this.riskstroke =  Risk_Obesity;

    }

}


 calCkdRisk(Age, Gender, SBP, DM, CHOL, Smoking, LDL, Waist, GFR, Height){


    let Risk_CKD_WC = parseFloat(String((1 / (1 + Math.exp(- (- 10.2735847304812 + ( 0.0558340642402623 * Age )+ ( 0.603337986716479 * Gender )+ 
    ( 0.023633303263198 * SBP )+ ( 0.558629350280779 * DM )+ ( 0.0159436039945489 * Waist )) ) ) ) * 100) ).toFixed(1);

    let Risk_CKD_GFR = parseFloat(String((1 / (1 + Math.exp(- (- 2.04778647579173 + ( 0.032495674460793 * Age )+ ( 0.429905904391341 * Gender )+ 
    ( 0.0235708216543738 * SBP )+ ( 1.00773417784297 * DM )- ( 0.0715117655989791 * GFR )) ) ) ) * 100)).toFixed(1);


    if (GFR > 0){
      this.riskckd = Risk_CKD_GFR;
    } else {
      this.riskckd = Risk_CKD_WC;
    }
}

  checkEvent() {
    const totalItems = this.checkBoxList.length;
    let i = 0;
    let smoke = 0;
    let bp = 120;
    let bmi = 90;
    this.checkBoxList.map(obj => {
      i++;
      //this.LastScreenResult;
      console.log(i);
      if (i === 1) {
        if (obj.isChecked) {
          smoke = 0;
        } else {
          smoke = this.LastScreenResult.smoking;
        }

      } else if (i === 2) {
        if (obj.isChecked) {
          bp = 110;
        } else {
          bp = this.LastScreenResult.bps;
        }

      } else if (i === 3) {
        if (obj.isChecked) {
          bmi = this.LastScreenResult.waist - 5;
        } else {
          bmi = this.LastScreenResult.waist;
        }

      }
    });
    this.calCkdRisk(
      //56,1,152,0,0,0,0,74,74.65,160
      this.LastScreenResult.age_y,
      this.LastScreenResult.sex,
      bp,
      //this.LastScreenResult.bps,
      this.LastScreenResult.dm,
      0,
      smoke,
      //this.LastScreenResult.smoking,
      this.LastScreenResult.ldl,
      bmi,
     // this.LastScreenResult.waist,
      this.LastScreenResult.egfr_ok,
      this.LastScreenResult.height
      );
    this.calStrokeRisk (
        //56,1,152,0,0,0,0,74,74.65,160
        this.LastScreenResult.age_y,
        this.LastScreenResult.sex,
      //  this.LastScreenResult.bps,
        bp,
        this.LastScreenResult.dm,
        0,
        smoke,
       // this.LastScreenResult.smoking,
        this.LastScreenResult.ldl,
        bmi,
        //this.LastScreenResult.waist,
        this.LastScreenResult.egfr_ok,
        this.LastScreenResult.height
        );



  }
  ionViewDidEnter() {
    this.createBarChartHt();
    this.createBarChartDm();
    this.checkEvent();
  }

  ionViewWillEnter() {
    this.apiService.getHistory(this.cid).subscribe(
      data => {
        this.history = data.rows;
      }
    );
    this.apiService.getProfile(this.cid).subscribe(
      data => {
        console.log(data);
        this.profile = data.rows[0];
      }
    );
    this.apiService.getLastScreenResult(this.cid).subscribe(
      data => {
        console.log(data);
        this.LastScreenResult = data.rows[0];
      }
    );
  }

  createBarChartHt() {
    this.apiService.getHtChart(this.cid).subscribe(
      data => {
        this.htchart = data.rows
        let label = []
        let length = this.htchart.length
        let SBP1 = []
        let DBP1 = []
        var i;
        for (i = 0; i < length; i++) {
          label[i] = this.htchart[i].DATE_SERV;
          SBP1[i] = this.htchart[i].SBP_1;
          DBP1[i] = this.htchart[i].DBP_1;
        }

        this.chart = new Chart(this.lineChartHt.nativeElement, {
          type: 'line',
          data: {
            labels: label,
            datasets: [{
              label: 'ความดันช่วงบน',
              fill: false,
              data: SBP1,
              backgroundColor: 'rgb(5, 40, 166)', // array should have same number of elements as number of dataset
              borderColor: 'rgb(38, 145, 195)',// array should have same number of elements as number of dataset
              borderWidth: 1
            },
            {
              label: 'ความดันช่วงล่าง',
              fill: false,
              data: DBP1,
              backgroundColor: 'rgb(5, 40, 166)', // array should have same number of elements as number of dataset
              borderColor: 'rgb(38, 145, 195)',// array should have same number of elements as number of dataset
              borderWidth: 1
            }
            ]
          },
          options: {
            legend: {
              display: false,
              position: 'top',
            },
            scales: {
              xAxes: [{
                display: true,
                scaleLabel: {
                  display: true,
                  labelString: 'กราฟแสดงค่าความดัน'
                }
              }],
              yAxes: [{
                display: false,
                scaleLabel: {
                  display: false,
                  labelString: 'Value'
                }
              }]
            }
          }
        })
      }
    )

  }

  createBarChartDm() {
    this.apiService.getDmChart(this.cid).subscribe(
      data => {
        this.dmchart = data.rows
        let label = []
        let length = this.dmchart.length
        let BSLEVEL = []
        var i;
        for (i = 0; i < length; i++) {
          label[i] = this.dmchart[i].DATE_SERV;
          BSLEVEL[i] = this.dmchart[i].BSLEVEL;
        }

        this.chart = new Chart(this.lineChartDm.nativeElement, {
          type: 'line',
          data: {
            labels: label,
            datasets: [{
              label: 'ค่าน้ำตาล',
              fill: false,
              data: BSLEVEL,
              backgroundColor: 'rgb(230, 0, 180)', // array should have same number of elements as number of dataset
              borderColor: 'rgb(255, 0, 255)',// array should have same number of elements as number of dataset
              borderWidth: 1
            }
            ]
          },
          options: {
            legend: {
              display: false,
              position: 'top',
            },
            scales: {
              xAxes: [{
                display: true,
                scaleLabel: {
                  display: true,
                  labelString: 'กราฟแสดงค่าน้ำตาล'
                }
              }],
              yAxes: [{
                display: false,
                scaleLabel: {
                  display: false,
                  labelString: 'Value'
                }
              }]
            }
          }
        })
      }
    )

  }

  goProfile(cid: any, fname: any, lname: any) {
    this.navController.navigateForward('/profile/' + cid + '/' + fname + '/' + lname)
    console.log(cid);
  }

  putHistory(rec_id: any) {
    this.navController.navigateForward('/screen/' + rec_id)
    console.log(rec_id);
  }
  async presentAlertConfirm(rec_id: any) {
    const alert = await this.alertController.create({
      header: 'คำเตือน!',
      message: 'ต้องการลบประวัติหรือไม่',
      buttons: [
        {
          text: 'ตกลง',
          handler: () => {
            this.apiService.deleteHistory(rec_id).subscribe(
              res => {
                console.log(res);
                if (res = 'OK') {
                 // this.navController.navigateForward('/history/' + cid + '/' + fname + '/' + lname + '/' + sex);
                //this.listItems[rec_id].hidden = true;
               // this.taskList.splice(rec_id, 1);
                  //this.posts.splice(index, 1);
                   //this.navController.navigateForward('/history');
                   location.reload();
                }
              }
            )
            console.log();
          }
        },
        {
          text: 'ยกเลิก',
          role: 'cancel',
          cssClass: 'secondary',
          handler: (blah) => {
            console.log('Confirm Cancel: blah');
          }
        }
      ]
    });
    await alert.present();
  }

  async AlertGreen() {
    const alert = await this.alertController.create({
      header: 'คำแนะนำ สีเขียว',
      // subHeader: 'การปฏิบัติตัว',
      message: `<p>-รับประทานยาต่อเนื่อง</p>
                <p>-รับยาทุก 3 เดือน</p>
                <p>-ลดอาหารจำพวกแป้งและน้ำตาล และตรวจเลือดประจำปี ตรวจเท้า ตรวจจอประสาทตาปีละ 1 ครั้ง ในผู้ป่วยเบาหวาน</p>
                <p>-ลดอาหาร หวาน มัน เค็ม และตรวจเลือดประจำปีๆละ1 ครั้ง ในผู้ป่วยความดันโลหิตสูง</p>`,
      buttons: ['OK']
    });

    await alert.present();
  }

  async AlertYellow() {
    const alert = await this.alertController.create({
      header: 'คำแนะนำ สีเหลือง',
      // subHeader: 'Subtitle',
      message: `<p>-รับประทานยาต่อเนื่อง</p>
              <p>-รับยาทุก 3 เดือน</p>
              <p>-ลดอาหารจำพวกแป้งและน้ำตาล และตรวจเลือดประจำปี ตรวจเท้า ตรวจจอประสาทตาปีละ 1 ครั้งในผู้ป่วยเบาหวาน</p>
              <p>-ลดอาหาร หวาน มัน เค็ม และตรวจเลือดประจำปีๆละ1 ครั้ง ในผู้ป่วยความดันโลหิตสูง</p>
              <p>-ถ้าระดับน้ำตาล หรือความคันโลหิตครั้งต่อไปยังอยู่ระดับเหลืองนัดรับยาและพบแพทย์ที่ PCU รพสต./โรงพยาบาล
              ถ้าระดับน้ำตาลหรือความดันโลหิตอยู่ระดับสีเขียวให้ยาต่อ 3 เดือน</p>`,
      buttons: ['OK']
    });

    await alert.present();
  }

  async AlertOrange() {
    const alert = await this.alertController.create({
      header: 'คำแนะนำ สีส้ม',
      // subHeader: 'Subtitle',
      message: `<p>-รับประทานยาต่อเนื่อง</p>
                <p>-ลดอาหารจำพวกแป้งและน้ำตาล และตรวจเลือดประจำปี ตรวจเท้า ตรวจจอประสาทตาปีละ 1 ครั้งในผู้ป่วยเบาหวาน</p>
                <p>-ลดอาหาร หวาน มัน เค็ม และตรวจเลือดประจำปีๆละ1 ครั้ง ในผู้ป่วยความดันโลหิตสูง</p>
                <p>-ไม่จ่ายยาและนัดพบแพทย์ที่ PCU รพสต./โรงพยาบาลตามวันคลินิก โรคเบาหวาน ในวันพุธเละพฤหัสบดี
                โรคความคันโลหิตสูงในวันจันทร์และศุกร์ ช่วงเช้า (08.00น.-12.00น.)</p>`,
      buttons: ['OK']
    });

    await alert.present();
  }

  async AlertRed() {
    const alert = await this.alertController.create({
      header: 'คำแนะนำ สีแดง',
      // subHeader: 'Subtitle',
      message: `<p>-รับประทานยาต่อเนื่อง</p>
                <p>-ลดอาหารจำพวกแป้งและน้ำตาล และตรวจเลือดประจำปี ตรวจเท้า ตรวจจอประสาทตาปีละ 1 ครั้งในผู้ป่วยเบาหวาน</p>
                <p>-ลดอาหาร หวาน มัน เค็ม และตรวจเลือดประจำปีๆละ1 ครั้ง ในผู้ป่วยความดันโลหิตสูง</p>
                <p>-ส่งพบแพทย์ที่โรงพยาบาลทันที อย่างเร่งด่วน</p>`,
      buttons: ['OK']
    });

    await alert.present();
  }

  deleteHistory(rec_id: any) {
    this.apiService.deleteHistory(rec_id).subscribe(
      res => {
        console.log(res);
        if (res = 'OK') {
        }
      }
    )
  }

  ngOnInit() {
  }

}
