import { Component, ViewChild } from '@angular/core';
import { MainPage } from '../main/main.page';
import { ChronicPage } from '../chronic/chronic.page';
import { RiskPage } from '../risk/risk.page';
import { NavController, Platform } from '@ionic/angular';
import { SuperTabs } from '@ionic-super-tabs/angular';
// import { SuperTabsConfig } from '@ionic-super-tabs/core';
// import { SuperTabs } from '@ionic-super-tabs/angular';

@Component({
  selector: 'app-home',
  templateUrl: 'home.page.html',
  styleUrls: ['home.page.scss'],
})
export class HomePage {
  @ViewChild(SuperTabs, { static: false }) superTabs: SuperTabs;

  opts = {
    icon: false,
    label: true,
    toolbarPos: 'top',
    scrollable: true,
  };

  // config: SuperTabsConfig = {
  //   dragThreshold: 300,
  //   allowElementScroll: false,
  //   maxDragAngle: 40,
  //   shortSwipeDuration: 180,
  //   avoidElements: false
  // };
  // config: SuperTabsConfig = {
  //   sideMenu: 'left',
  //   shortSwipeDuration: 180,
  // };
  subscription

  mainPage = MainPage;
  chronicPage = ChronicPage;
  riskPage = RiskPage;

  constructor(
    private navController: NavController,
    private platform: Platform
    // private superTabs: SuperTabs
  ) {
    // this.superTabs.config = {
    //   allowElementScroll: true
    // };

  }

  ionViewWillEnter() {
    // this.superTabsContainer.swipeEnabled = true
  }

  ionViewDidEnter() {
    this.subscription = this.platform.backButton.subscribe(() => {
      let i = this.superTabs.activeTabIndex;
      if (i == 0) {
        navigator['app'].exitApp();
      } else {
        this.superTabs.selectTab(0);
        this.superTabs.activeTabIndex = 0;
      }
    });
  }

  ionViewWillLeave() {
    this.subscription.unsubscribe();
  }

  myPage() {
    this.navController.navigateForward('/profile')
  }

}
