import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AuthenService } from '../services/authen.service';
import { Storage } from '@ionic/storage';
import { NavController, AlertController } from '@ionic/angular';

@Component({
  selector: 'app-login',
  templateUrl: './login.page.html',
  styleUrls: ['./login.page.scss'],
})
export class LoginPage implements OnInit {
  // id : any
  // cid : any
  username: string
  password: string

  constructor(
    private activatedRoute: ActivatedRoute,
    private authenService: AuthenService,
    private storage: Storage,
    private navController: NavController,
    private alertController: AlertController
  ) {
    // this.id = activatedRoute.snapshot.paramMap.get('id')//id มาจากหน้า app-routing login
    // this.cid = activatedRoute.snapshot.paramMap.get('cid')
  }

  ngOnInit() {
  }

  doLogin() {
    this.authenService.doAuthen(this.username, this.password).subscribe(
      data => {
        // console.log(data);
        // console.log(data.dataUser);
        if (data.ok) {
          let userData = {
            'cid': data.dataUser[0].CID,
            'fullname': data.dataUser[0].fname + ' ' + data.dataUser[0].lname,
            'hospcode': data.dataUser[0].HOSPCODE,
            'token': data.token
          }
          // console.log(userData);
          this.storage.set('user', userData)
          this.navController.navigateForward('/home')
        } else {
          this.presentAlertMultipleButtons()
        }

      }
    )
  }

  async presentAlertMultipleButtons() {
    const alert = await this.alertController.create({
      header: 'แจ้งเตือน',
      subHeader: 'ข้อความระบบ',
      message: 'username หรือ password ไม่ถูกต้อง โปรดลองอีกครั้ง',
      buttons: ['ตกลง']
    });
    await alert.present();
  }

}