import { Component, OnInit } from '@angular/core';
import { NavController } from '@ionic/angular';
import { Router } from '@angular/router';
import { ApiService } from '../services/api.service';
import { Storage } from '@ionic/storage';
import { SuperTabs } from '@ionic-super-tabs/angular';

@Component({
  selector: 'app-main',
  templateUrl: './main.page.html',
  styleUrls: ['./main.page.scss'],
})
export class MainPage implements OnInit {
  patienCare: any
  patienCareHistory: any
  userData: any
  fullname: string
  profile: any

  constructor(
    private navController: NavController,
    private router: Router,
    private apiService: ApiService,
    private storage: Storage,
    private superTabs: SuperTabs
  ) { }

  ngOnInit() {

  }

  //ดึงค่าจาก API มาโชว์
  ionViewWillEnter() {
    this.storage.get('user').then(user => {
      if (!user) {
        this.navController.navigateForward('/login')
      } else {
        this.apiService.getProfile(user.cid).subscribe(
          data => {
            this.profile = data.rows[0]
          })
      }
    })
  }

  ionViewDidEnter() {
    this.storage.get('user').then(user => {
      this.fullname = user.fullname
    })
  }

  myPage() {
    this.navController.navigateForward('/profile')
  }

  openChronic() {
    this.superTabs.selectTab(1)
  }

  openRisk() {
    this.superTabs.selectTab(2)
  }
  openCalendar() {
    this.navController.navigateForward('/calendar')
  }

  openAbout() {
    this.superTabs.selectTab(4)
  }

  openNews() {
    this.navController.navigateForward('/news')
  }

  goHistory(cid: any) {
    this.apiService.getHistory(cid).subscribe(
      data => {
        this.patienCareHistory = data.row
      }
    )
  }

}
