import { Component, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { NavController } from '@ionic/angular';
import { ApiService } from '../services/api.service';
import { Storage } from '@ionic/storage';

@Component({
  selector: 'app-profile',
  templateUrl: './profile.page.html',
  styleUrls: ['./profile.page.scss'],
})
export class ProfilePage implements OnInit {
  fullname: any
  profile: any
  hospcode: any
  cid: any

  constructor(
    private apiService: ApiService,
    private storage: Storage,
    private navController: NavController
  ) {}

  ngOnInit() {
  }

  ionViewWillEnter() {
    this.storage.get('user').then(user => {
      this.fullname = user.fullname
      this.hospcode = user.hospcode
      this.cid = user.cid
      this.apiService.getProfile(user.cid).subscribe(
        data => {
          this.profile = data.rows[0]
        })
    })

  }

  logout(){
    // this.storage.remove('user')
    this.storage.clear()
    this.navController.navigateBack('/login')
  }

}
