import { Component, OnInit } from '@angular/core';
import { NavController, ActionSheetController } from '@ionic/angular';
import { ApiService } from '../services/api.service';
import { Storage } from '@ionic/storage';

@Component({
  selector: 'app-risk',
  templateUrl: './risk.page.html',
  styleUrls: ['./risk.page.scss'],
})
export class RiskPage implements OnInit {

  items;
  patienCare: any
  patienCareHistory: any
  riskCare: any
  hospcode: any
  username: string
  event: any
  ev: any
  search: any
  tempPatienCare: any
  tempRiskCare: any
  sex: any

  constructor(
    public navController: NavController,
    public actionSheetController: ActionSheetController,
    public apiService: ApiService,
    public storage: Storage,
  ) {
  }

  ngOnInit() {
  }

  //ดึงค่าจาก API มาโชว์
  ionViewWillEnter() {
    this.storage.get('user').then(
      res => {
        this.apiService.getRisk(res.hospcode, res.cid).subscribe(
          data => {
            // console.log(data);
            // console.log(data.rows);
            this.riskCare = data.rows
            this.tempRiskCare = data.rows
          }
        )
      }
    )
  }

  getItems() {
    // Reset items back to all of the items
    // console.log(this.search);
    if (this.search) {
      this.apiService.getSearchRisk(this.search).subscribe(
        data => {
          this.riskCare = data.rows
          // console.log(data.rows);
        }
      )
    } else {
      this.riskCare = this.tempRiskCare
    }
  }

  async presentActionSheet(cid: any, fname: any, lname: any, sex: any) {
    const actionSheet = await this.actionSheetController.create({
      buttons: [{
        text: 'บันทึกข้อมูลกลุ่มเสี่ยง',
        role: 'destructive',
        icon: 'create',
        handler: () => {
          // console.log('Delete clicked');
          this.navController.navigateForward('/screen/' + cid + '/' + fname + '/' + lname +'/'+ sex)
          // console.log(fname);

        }
      },
      {
        text: 'ประวัติ',
        icon: 'contact',
        handler: () => {
          // console.log('Play clicked');
          this.navController.navigateForward('/history/' + cid + '/' + fname + '/' + lname + '/' + sex)
        }
      }, {
        text: 'ยกเลิก',
        icon: 'close',
        role: 'cancel',
        handler: () => {
          // console.log('Cancel clicked');
        }
      }]
    });
    await actionSheet.present();
  }

  showHistory(cid: any, fname: any, lname: any, sex: any) {
    this.navController.navigateForward('/history/' + cid + '/' + fname + '/' + lname + '/' + sex)
  }

}