import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';

const API = 'http://203.157.145.19:3002'
const API_URL = 'http://203.157.145.19'

@Injectable({
  providedIn: 'root'
})
export class ApiService {
  public apiKey: any = '67f08b2a63774e5d8408f130d15bb65f';

  constructor(
    private http: HttpClient,
  ) { }

  getChronic(hospcode:string, username:string): Observable<any>{
    return this.http.get<any>(`${API}/chronic/hospcode/${hospcode}/${username}`)
  }

  getRisk(hospcode:string, username:string): Observable<any>{
    return this.http.get<any>(`${API}/risk/hospcode/${hospcode}/${username}`)
  }

  getSearchChronic(event:string): Observable<any>{
    return this.http.get<any>(`${API}/chronic/search/${event}`) 
  }

  getSearchRisk(event:string): Observable<any>{
    return this.http.get<any>(`${API}/risk/search/${event}`) 
  }

  getHistory(cid:string): Observable<any>{
    return this.http.get<any>(`${API}/ncdscreen/cid/${cid}`)
  }

  putHistory(rec_id:string): Observable<any>{
    return this.http.get<any>(`${API}/ncdscreen/rec_id/${rec_id}`)
  }
  
  deleteHistory(rec_id:string): Observable<any>{
    return this.http.get<any>(`${API}/ncdscreen/rec_id/${rec_id}`)
  }

  getHtChart(cid:string): Observable<any> {
    return this.http.get<any>(`${API}/ncdscreen/htchart/cid/${cid}`);
  }

  getDmChart(cid:string): Observable<any> {
    return this.http.get<any>(`${API}/ncdscreen/dmchart/cid/${cid}`);
  }

  getProfile(cid: string): Observable<any> {
    return this.http.get<any>(`${API}/chronic/cid/${cid}`);
  }

  getLastScreenResult(cid: string): Observable<any>{
    return this.http.get<any>(`${API}/ncdscreen/last_screen_result/cid/${cid}`);
  }

  postScreen(body) {
    let myHeader = {'Authorization': 'my-auth-token' }
    return this.http.post(`${API}/ncdscreen/`, body, { headers : myHeader})
    // {
    //   headers: new HttpHeaders().set('Authorization', 'my-auth-token'),
    //   params: new HttpParams().set('id', '3'),
    // }
  }

  getNews() {
    return this.http.get(`https://newsapi.org/v2/top-headlines?country=th&category=health&apiKey=${this.apiKey}`);
  } 

  getAppoint(user_id: string): Observable<any>{
    return this.http.get<any>(`${API}/appoint/${user_id}/${user_id}`)
  }

  getPictureList(userid:string, rec_id:string): Observable<any[]> {
    const myHeader = {'Content-type' : 'application/json'} 
    const myForm = {'userid' : userid, 'rec_id' : rec_id} 
    return this.http.post<any>(`${API_URL}/ncd/api_service/ncd_as_home/get_picture_list.php`,myForm,{headers : myHeader})
  }

  deletePhoto(img:string, token:string): Observable<any[]> {
    const myHeader = {'Content-type' : 'application/json'} 
    const myForm = {'img' : img , 'token' : token, API_KEY : 'I740a9H13894ddKey2f16d61aH9e161Cb7a56eb4bS0'} 
    return this.http.post<any>(`${API_URL}/ncd/api_service/ncd_as_home/photo_delete.php`,myForm,{headers : myHeader})
  }

  putMobileAlert(cid: string, fullname : string, app: string, uuid: string, token: string): Observable<any>{
    return this.http.get<any>(`${API_URL}/appoint/${cid}`)
  }
}
